% pdfTraceWishartTEST
%
% Tests pdfTraceWishart against the results of a Monte-Carlo experiment.
%
% Copyright (c) Plamen Koev, Massachusetts Institute of Technology
% May 17, 2005. See COPYRIGHT.TXT for details.


   % Choose values for the parameters; 

   m=4; Sigma=[0.25,0.4, 1];

   x=[0:0.05:30];


   n=length(Sigma);  % We must have m>=n !!!!

   MAX=16; % how far should the hypergeometric series be truncated
           % larger values of M yield more accurate results, but
           % take longer to compute


   beta=1; % meaning alpha=2; this is the REAL case


   
   nn=10000;               % # of trials
   colormap(white);
   clf;
   hold off
 
   r=zeros(1,nn);
  
% set(0,'defaultaxesfontsize',12,'defaultaxeslinewidth',0.7, ...
%      'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);

   SqrtSigma=sqrt(Sigma);
   for j=1:nn
      A=randn(m,n);
      for i=1:n, A(:,i)=A(:,i)*SqrtSigma(i); end
      r(j)=trace(A'*A);
   end
   
   z=pdfTraceWishart(MAX,x,Sigma,m);
   [N,X]=hist(r,40);
   bar(X,N/sum(N)/(X(2)-X(1))); hold on;
   plot(x,z,'linewidth',2); hold on
   s=strcat('pdf of tr(A), A=W_',num2str(n),'(', ...
    num2str(m),',diag(');

  for i=1:length(Sigma)-1
    s=strcat(s,num2str(Sigma(i)),',');
  end
  s=strcat(s,num2str(Sigma(length(Sigma))),'))');

   title(s);
   xlabel('x');
